# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph,
#               Hooman Asadian, Sarbojit Das
# Assignment 3 - Hash Tables and Binary Search Trees
# Name 1: Neethu Joseph
# Name 2: Henrik Schulze
# This version is for Python 3.x.x - ass3ht_python3.py
import random

# Construct an empty hash table with n buckets
def ht(n):
    return list(map(lambda x: [],range(n)))

# Print the hash table
def output(t):
    for k in range(0,len(t)):
        s = str(k) + ": "
        if len(t[k]) <= 30:
            for i,e in enumerate(t[k]):
                if i != 0: s = s + ","
                s = s + str(e)
        else:
            s = s + "(" + str(len(t[k])) + " elements)"
        print(s)

# Random DNA string of length 2*n
def randstring(n):
    return "".join(random.choice(["AT","TA","CG","GC"]) for i in range(0,n))

# Hash function h0, 3 buckets:
def h0(e):
    return (5 * e) % 3

# Hash function h1, 11 buckets:
def h1(e):
    return (37 * e) % 11

# Hash function h2, 8 buckets:
def h2(e):
    return (30 * e) % 8 

# Hash function h3, 23 buckets:
def h3(e):
    return (e*e) % 23

# Hash function h4, defined on strings, as the sum of all character values:
def h4(e):
    return sum(map(ord, e)) % 19

# Inserts the element e into the hash table t using hash function h:
def insert(t, h, e):
    k = h(e)
    t[k].append(e)

# Returns True if the element e exists in the hash table t, else False:
def search(t, h, e):
    k = h(e)
    return (t[k].count(e)>0)

# Deletes the element e from the hash table t. Assumes h was used for hashing:
def delete(t, h, e):
    k = h(e)
    try: t[k].remove(e)
    except ValueError: pass # Do nothing - no reason to get upset! :-)

# Greeting, will called when this module is imported:
print("Hello Hash Tables!")
# ^^ This should of course be removed in a "production environment".
