# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph,
#               Hooman Asadian, Sarbojit Das
# Assignment 3 - Hash Tables and Binary Search Trees
# Name 1: Neethu Joseph
# Name 2: Henrik Schulze
# ass3bst.py

# Create an empty tree:
def emptytree (): return None

# Insert x into tree t:
def insert(t,x):
    if t == None:
        return (x,None ,None)
    else:
        (key,left,right) = t
        if x == key: return (key,left,right) # Node exists - do nothing.
        elif x < key: return (key,insert(left,x),right) # Insert to left
        else: return (key,left,insert(right,x))         # Insert to right

# Create tree - insert each element in list into an initially empty tree:
def treefromlist(list):
    t=emptytree()
    for x in range(0,(len(list))):
        t = insert(t,list[x])
    return t

# Print the elements of a tree by making an inorder walk:
def inorderwalk(t):
    inorder(t)
    print()
def inorder(t):
    (key,left,right) = t
    if left is not None: inorder(left)
    if key is not None: print(str(key) + " ",end='')
    if right is not None: inorder(right)
# ^^ See the slides for lecture 7, page 10.

# Function delete(t,x) -- returns the tree t with x removed:
def delete(t,x):
    if t == None:
        return None
    else:
        (key,left,right) = t
        if x == key: return deleteroot(t)
        elif x < key: return (key,delete(left,x),right)
        else: return (key,left,delete(right,x))
def deleteroot(t):
    # print("deleteroot")
    (key,left,right) = t
    if left is None: return right       # Fig 12.4 a)
    elif right is None: return left     # Fig 12.4 b)
    else:
        (_,l,(rk,rl,rr)) = t
        if rl is None:       # Fig 12.4 c) y.left (='rl') --> l
            return (rk,l,rr) # Fig 12.4 c) return y (='right'; rl --> l)
        else:
            (_,l,r) = t       # Fig 12.4 d)
            skey = minimum(r)
            return (skey,l,tended(r))
# See Figure 12.4, p 297, CLRS 3rd ed.

# Return the minimum *key* of a tree:
def minimum(t):
    if t[1] is not None: return minimum(t[1])
    return t[0]
# ^^ See the slides for lecture 7, page 16.

# Return the 'tended' tree, where the "minimum node" has been removed:
def tended(r):
    (pkey,lc,rc) = r
    (lckey,lgc,rgc) = lc
    if lgc is None: return (pkey,rgc,rc)
    else: return (pkey,tended(lc),rc)
# See Figure 12.4 d), p 297, CLRS 3rd ed, 'tended(r)' = r with y removed.

# Greeting, will called when this module is imported:
print("Hello Binary Search Trees!")
# ^^ This should of course be removed in a "production environment".
